"use strict";

var util = require('util');

var sents = [
  ['&','&amp;',/&/g,/&amp;/g],
  ['<','&lt;' ,/</g,/&lt;/g ],
  ['>','&gt;' ,/>/g,/&gt;/g ]
];

function parseXML(){
  var root = {
    nodeName: 'root',
    childNodes: []
  };
  var current = root;
  var parse;
  var ch,tmp;
  var tagState;
  var slash;
  newText();
  function newTag(){
    ch = {
      nodeName: '',
      childNodes: [],
      attribute: {},
      parentNode: current
    };
    parse = parseTag;
  }
  function parseTag(c){
    if( c == '>' && tagState != "attrValue" ){
      if( tagState != "close" ){
        current.childNodes.push(ch);
        if(!slash)
          current = ch;
      }
      newText();
      return true;
    }
    slash = false;
    if( c == '/' )
      slash = true;
    switch( tagState ){
      case 'nodeName': {
        if( c == '/' && !ch.nodeName ){
          current = current.parentNode;
          tagState = 'close';
          break;
        }
        if( /\s|>/.test(c) ){
          tagState = "spaces";
        }else{
          if( c != '/' )
            ch.nodeName += c;
        }
      } break;
      case "spaces": {
        if( !(/\s|>/.test(c)) ){
          tagState = 'attrName';
          tmp = ['',''];
          return false
        }
      } break;
      case 'attrName': {
        if( c == '=' ){
          tagState = 'attrValue';
        }else tmp[0] += c;
      } break;
      case 'attrValue': {
        if( c == tmp[1][0] ){
          ch.attribute[tmp[0]] = tmp[1].substr(1);
          tagState = 'spaces';
        }else tmp[1] += c;
      } break;
    };
    return true;
  }
  function newText(){
    ch={
      nodeName: '#text',
      childNodes: [],
      parentNode: current,
      content: ''
    };
    tagState = 'nodeName';
    parse = parseText;
  }
  function parseText( c ){
    if( c == '<' ){
      newTag();
      return true;
    }
    if(!ch.content.length)
      current.childNodes.push(ch);
    ch.content += c;
    return true;
  }
  return function( str ){
    var i=0,n=str.length;
    while( i < n )
      if(parse(str[i]))
        i++;
    return root.childNodes;
  };
}

function serializeXML( tree ){
  var str = '';
  for( var node of tree ){
    if( node.nodeName == '#text' ){
      var s = node.content||'';
      for( var sent of sents )
        s = s.replace( sent[2], sent[1] );
      str += s;
    }else{
      str += '<' + node.nodeName;
      for( var key in node.attribute ){
        str += ' ' + key + '="' + (node.attribute[key].replace('"',"&quot;")) + '"';
      }
      if(!node.childNodes.length){
        str += '/>';
      }else{
        str += '>';
        str += serializeXML(node.childNodes);
        str += '</' + node.nodeName + '>';
      }
    }
  }
  return str;
}

module.exports.parseXML     = parseXML;
module.exports.serializeXML = serializeXML;
