#!/usr/bin/env nodejs
"use strict";

var fs = require('fs');
var QS = {};

if( process.env.QUERY_STRING ){
  process.env.QUERY_STRING.split("&").forEach( (x) => {
    var res = x.match(/^([^=]+)(=(.+))?$/m);
    QS[res[1]] = res[3];
  });
}

global.sendResponseHeader = sendResponseHeader;
global.QS = QS;
global.write = write;
global.root = process.env.DOCUMENT_ROOT;
global.url = process.env.REQUEST_URI.match(/^[^?]*/)[0];

if(process.env.HTTP_ACCEPT_LANGUAGE){
  var l = process.env.HTTP_ACCEPT_LANGUAGE.replace(/q=\d(.\d)?,?/g,'').replace(/;|,/g,':');
  if(l[l.length-1]!=':')
    l+=':';
  global.langs = l+'*';
}else{
  global.langs = '*';
}

function write(x){
  process.stdout.write(x);
}

function sendResponseHeader( header ){
  header = header || {};
  var s = '';
  for( var key in header )
    s += key + ': ' + header[key] + "\r\n";
  write( s +"\r\n" );
}

var handlers = {};

require("./renderer/noscript.js")(handlers);

if( "render" in (handlers[QS.type]||{}) ){
  handlers[QS.type].render();
}else{
  sendResponseHeader({
    "Content-Type": "text/html; charset=utf8"
  });
  fs.readFile( root + "/root/default.html", 'utf8', function( error, string ){
    if( error )
      throw err;
    write(string);
  });
}
